# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::CognitiveServices::LuisAuthoring::V3_0_preview
  module Models
    #
    # Object model of an application version.
    #
    class VersionInfo

      include MsRestAzure

      # @return [String] The version ID. E.g.: "0.1"
      attr_accessor :version

      # @return [DateTime] The version's creation timestamp.
      attr_accessor :created_date_time

      # @return [DateTime] Timestamp of the last update.
      attr_accessor :last_modified_date_time

      # @return [DateTime] Timestamp of the last time the model was trained.
      attr_accessor :last_trained_date_time

      # @return [DateTime] Timestamp when was last published.
      attr_accessor :last_published_date_time

      # @return [String] The Runtime endpoint URL for this model version.
      attr_accessor :endpoint_url

      # @return [Hash{String => String}] The endpoint key.
      attr_accessor :assigned_endpoint_key

      # @return External keys.
      attr_accessor :external_api_keys

      # @return [Integer] Number of intents in this model.
      attr_accessor :intents_count

      # @return [Integer] Number of entities in this model.
      attr_accessor :entities_count

      # @return [Integer] Number of calls made to this endpoint.
      attr_accessor :endpoint_hits_count

      # @return [TrainingStatus] The current training status. Possible values
      # include: 'NeedsTraining', 'InProgress', 'Trained'
      attr_accessor :training_status


      #
      # Mapper for VersionInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'VersionInfo',
          type: {
            name: 'Composite',
            class_name: 'VersionInfo',
            model_properties: {
              version: {
                client_side_validation: true,
                required: true,
                serialized_name: 'version',
                type: {
                  name: 'String'
                }
              },
              created_date_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'createdDateTime',
                type: {
                  name: 'DateTime'
                }
              },
              last_modified_date_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastModifiedDateTime',
                type: {
                  name: 'DateTime'
                }
              },
              last_trained_date_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastTrainedDateTime',
                type: {
                  name: 'DateTime'
                }
              },
              last_published_date_time: {
                client_side_validation: true,
                required: false,
                serialized_name: 'lastPublishedDateTime',
                type: {
                  name: 'DateTime'
                }
              },
              endpoint_url: {
                client_side_validation: true,
                required: false,
                serialized_name: 'endpointUrl',
                type: {
                  name: 'String'
                }
              },
              assigned_endpoint_key: {
                client_side_validation: true,
                required: false,
                serialized_name: 'assignedEndpointKey',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              external_api_keys: {
                client_side_validation: true,
                required: false,
                serialized_name: 'externalApiKeys',
                type: {
                  name: 'Object'
                }
              },
              intents_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'intentsCount',
                type: {
                  name: 'Number'
                }
              },
              entities_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'entitiesCount',
                type: {
                  name: 'Number'
                }
              },
              endpoint_hits_count: {
                client_side_validation: true,
                required: false,
                serialized_name: 'endpointHitsCount',
                type: {
                  name: 'Number'
                }
              },
              training_status: {
                client_side_validation: true,
                required: true,
                serialized_name: 'trainingStatus',
                type: {
                  name: 'Enum',
                  module: 'TrainingStatus'
                }
              }
            }
          }
        }
      end
    end
  end
end
